const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const items = sequelize.define(
    'items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_name: {
        type: DataTypes.TEXT,
      
      

      },

item_code: {
        type: DataTypes.TEXT,
      
      

      },

item_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"raw_material",


"wip",


"finished_good",


"consumable",


"spare_part"

        ],

      },

lot_tracked: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

serial_tracked: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

standard_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

default_purchase_price: {
        type: DataTypes.DECIMAL,
      
      

      },

default_sale_price: {
        type: DataTypes.DECIMAL,
      
      

      },

shelf_life_days: {
        type: DataTypes.INTEGER,
      
      

      },

reorder_point: {
        type: DataTypes.DECIMAL,
      
      

      },

reorder_qty: {
        type: DataTypes.DECIMAL,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.items.hasMany(db.lots, {
      as: 'lots_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.inventory_transactions, {
      as: 'inventory_transactions_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.boms, {
      as: 'boms_parent_item',
      foreignKey: {
          name: 'parent_itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.bom_lines, {
      as: 'bom_lines_component_item',
      foreignKey: {
          name: 'component_itemId',
      },
      constraints: false,
    });








    db.items.hasMany(db.work_orders, {
      as: 'work_orders_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });




    db.items.hasMany(db.material_issue_lines, {
      as: 'material_issue_lines_component_item',
      foreignKey: {
          name: 'component_itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.receipt_lines, {
      as: 'receipt_lines_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.shipment_lines, {
      as: 'shipment_lines_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.qa_inspection_plans, {
      as: 'qa_inspection_plans_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.qa_inspections, {
      as: 'qa_inspections_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.nonconformances, {
      as: 'nonconformances_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });




//end loop



    db.items.belongsTo(db.item_categories, {
      as: 'category',
      foreignKey: {
        name: 'categoryId',
      },
      constraints: false,
    });

    db.items.belongsTo(db.uoms, {
      as: 'uom',
      foreignKey: {
        name: 'uomId',
      },
      constraints: false,
    });



    db.items.hasMany(db.file, {
      as: 'spec_documents',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.items.getTableName(),
        belongsToColumn: 'spec_documents',
      },
    });


    db.items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return items;
};


